#!/bin/bash

# 获取当前用户的 UID
current_uid=$(id -u)

# 获取脚本名（包含参数，去掉路径）
script_name="$(basename "$0") $@"
current_dir=$(pwd)

if [ "$current_uid" -eq 0 ]; then
    # 通过 D-Bus 发送 system 级请求
    dbus-send --system \
        --reply-timeout=100000000000 \
        --print-reply \
        --dest=org.kaiming.proxy \
        /org/kaiming/proxy \
        org.kaiming.proxy.system.startBinaryAsUser \
        int32:"$current_uid" \
        string:"$script_name" \
        string:"$current_dir"
else
    # 通过 D-Bus 发送 session 级请求
    dbus-send --session \
        --reply-timeout=100000000000 \
        --print-reply \
        --dest=org.kaiming.proxy \
        /org/kaiming/proxy \
        org.kaiming.proxy.session.startBinaryAsUser \
        int32:"$current_uid" \
        string:"$script_name" \
        string:"$current_dir"
fi